package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo   {
  @JsonProperty("totalRows")
  private Long totalRows;

  @JsonProperty("currentPage")
  private Integer currentPage;

  @JsonProperty("currentSize")
  private Integer currentSize;

  @JsonProperty("data")
  @Valid
  private List<VirtualWanInfoOpenApiVo> data = null;

  @JsonProperty("supportMssClamping")
  private Boolean supportMssClamping;

  @JsonProperty("supportPppoeMru")
  private Boolean supportPppoeMru;

  @JsonProperty("numReachLimit")
  private Boolean numReachLimit;

  public VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo totalRows(Long totalRows) {
    this.totalRows = totalRows;
    return this;
  }

  /**
   * Total rows of all items.
   * @return totalRows
  */
  @ApiModelProperty(value = "Total rows of all items.")


  public Long getTotalRows() {
    return totalRows;
  }

  public void setTotalRows(Long totalRows) {
    this.totalRows = totalRows;
  }

  public VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo currentPage(Integer currentPage) {
    this.currentPage = currentPage;
    return this;
  }

  /**
   * Current page number.
   * @return currentPage
  */
  @ApiModelProperty(value = "Current page number.")


  public Integer getCurrentPage() {
    return currentPage;
  }

  public void setCurrentPage(Integer currentPage) {
    this.currentPage = currentPage;
  }

  public VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo currentSize(Integer currentSize) {
    this.currentSize = currentSize;
    return this;
  }

  /**
   * Number of entries per page.
   * @return currentSize
  */
  @ApiModelProperty(value = "Number of entries per page.")


  public Integer getCurrentSize() {
    return currentSize;
  }

  public void setCurrentSize(Integer currentSize) {
    this.currentSize = currentSize;
  }

  public VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo data(List<VirtualWanInfoOpenApiVo> data) {
    this.data = data;
    return this;
  }

  public VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo addDataItem(VirtualWanInfoOpenApiVo dataItem) {
    if (this.data == null) {
      this.data = new ArrayList<>();
    }
    this.data.add(dataItem);
    return this;
  }

  /**
   * Get data
   * @return data
  */
  @ApiModelProperty(value = "")

  @Valid

  public List<VirtualWanInfoOpenApiVo> getData() {
    return data;
  }

  public void setData(List<VirtualWanInfoOpenApiVo> data) {
    this.data = data;
  }

  public VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo supportMssClamping(Boolean supportMssClamping) {
    this.supportMssClamping = supportMssClamping;
    return this;
  }

  /**
   * Whether the pppoe supports mss clamping.
   * @return supportMssClamping
  */
  @ApiModelProperty(value = "Whether the pppoe supports mss clamping.")


  public Boolean getSupportMssClamping() {
    return supportMssClamping;
  }

  public void setSupportMssClamping(Boolean supportMssClamping) {
    this.supportMssClamping = supportMssClamping;
  }

  public VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo supportPppoeMru(Boolean supportPppoeMru) {
    this.supportPppoeMru = supportPppoeMru;
    return this;
  }

  /**
   * Whether the virtual WAN supports configuring pppoe mru.
   * @return supportPppoeMru
  */
  @ApiModelProperty(value = "Whether the virtual WAN supports configuring pppoe mru.")


  public Boolean getSupportPppoeMru() {
    return supportPppoeMru;
  }

  public void setSupportPppoeMru(Boolean supportPppoeMru) {
    this.supportPppoeMru = supportPppoeMru;
  }

  public VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo numReachLimit(Boolean numReachLimit) {
    this.numReachLimit = numReachLimit;
    return this;
  }

  /**
   * Whether the virtual WAN reaches number limit.
   * @return numReachLimit
  */
  @ApiModelProperty(value = "Whether the virtual WAN reaches number limit.")


  public Boolean getNumReachLimit() {
    return numReachLimit;
  }

  public void setNumReachLimit(Boolean numReachLimit) {
    this.numReachLimit = numReachLimit;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo virtualWanGridOpenApiVoVirtualWanInfoOpenApiVo = (VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo) o;
    return Objects.equals(this.totalRows, virtualWanGridOpenApiVoVirtualWanInfoOpenApiVo.totalRows) &&
        Objects.equals(this.currentPage, virtualWanGridOpenApiVoVirtualWanInfoOpenApiVo.currentPage) &&
        Objects.equals(this.currentSize, virtualWanGridOpenApiVoVirtualWanInfoOpenApiVo.currentSize) &&
        Objects.equals(this.data, virtualWanGridOpenApiVoVirtualWanInfoOpenApiVo.data) &&
        Objects.equals(this.supportMssClamping, virtualWanGridOpenApiVoVirtualWanInfoOpenApiVo.supportMssClamping) &&
        Objects.equals(this.supportPppoeMru, virtualWanGridOpenApiVoVirtualWanInfoOpenApiVo.supportPppoeMru) &&
        Objects.equals(this.numReachLimit, virtualWanGridOpenApiVoVirtualWanInfoOpenApiVo.numReachLimit);
  }

  @Override
  public int hashCode() {
    return Objects.hash(totalRows, currentPage, currentSize, data, supportMssClamping, supportPppoeMru, numReachLimit);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VirtualWanGridOpenApiVoVirtualWanInfoOpenApiVo {\n");
    
    sb.append("    totalRows: ").append(toIndentedString(totalRows)).append("\n");
    sb.append("    currentPage: ").append(toIndentedString(currentPage)).append("\n");
    sb.append("    currentSize: ").append(toIndentedString(currentSize)).append("\n");
    sb.append("    data: ").append(toIndentedString(data)).append("\n");
    sb.append("    supportMssClamping: ").append(toIndentedString(supportMssClamping)).append("\n");
    sb.append("    supportPppoeMru: ").append(toIndentedString(supportPppoeMru)).append("\n");
    sb.append("    numReachLimit: ").append(toIndentedString(numReachLimit)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

